FirstChanceExceptionEventArgs Klasse

Definition

Stellt Daten für das Benachrichtigungsereignis bereit, das beim erstmaligen Auftreten einer verwalteten Ausnahme ausgelöst wird, bevor die Common Language Runtime beginnt, nach Ereignishandlern zu suchen.Provides data for the notification event that is raised when a managed exception first occurs, before the common language runtime begins searching for event handlers.

public ref class FirstChanceExceptionEventArgs : EventArgs
public class FirstChanceExceptionEventArgs : EventArgs
type FirstChanceExceptionEventArgs = class
    inherit EventArgs
Public Class FirstChanceExceptionEventArgs
Inherits EventArgs
Vererbung
FirstChanceExceptionEventArgs

Beispiele

Im folgenden Beispiel wird eine Reihe von Anwendungs Domänen Child_0 , Child_3die durch benannt Worker sind, mit einem-Objekt in jeder Anwendungsdomäne erstellt.The following example creates a series of application domains named Child_0 through Child_3, with a Worker object in each application domain. Jedes Worker -Objekt verfügt über einen Verweis Worker auf das-Objekt in der nächsten Anwendungsdomäne, Worker mit Ausnahme der in der letzten Anwendungsdomäne.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. Das FirstChanceException Ereignis wird in allen Anwendungs Domänen außer Child_1behandelt.The FirstChanceException event is handled in all application domains except Child_1.

Wenn die Anwendungs Domänen erstellt wurden, ruft die Standard Anwendungsdomäne die TestException -Methode für die erste untergeordnete Anwendungsdomäne auf.When the application domains have been created, the default application domain calls the TestException method for the first child application domain. Jedes Worker -Objekt ruft TestException die-Methode für den nächsten auf, Worker bis der letzte eine Ausnahme auslöst, die entweder behandelt oder nicht behandelt wird.Each Worker object calls the TestException method for the next, until the last Worker throws an exception that is either handled or unhandled. Folglich durchläuft der aktuelle Thread alle Anwendungs Domänen und TestException wird dem Stapel in den einzelnen Anwendungs Domänen hinzugefügt.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

Wenn das letzte Worker Objekt die Ausnahme behandelt, wird FirstChanceException das Ereignis nur in der letzten Anwendungsdomäne ausgelöst.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. Die anderen Anwendungs Domänen erhalten nie die Möglichkeit, die Ausnahme zu behandeln, sodass das Ereignis nicht ausgelöst wird.The other application domains never get a chance to handle the exception, so the event is not raised.

Wenn das letzte Worker Objekt die Ausnahme nicht behandelt, wird das FirstChanceException -Ereignis in jeder Anwendungsdomäne ausgelöst, die über einen Ereignishandler verfügt.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. Nachdem jeder Ereignishandler beendet wurde, wird der Stapel fortgesetzt, bis die Ausnahme von der Standard Anwendungsdomäne abgefangen wird.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

Hinweis

Ändern e.Exception.Message Sie e.Exception in denFirstChanceHandler Ereignis Handlern in, um zu sehen, wie die Stapel Anzeige zunimmt, wenn das Ereignis näher und näher an der Standard Anwendungsdomäne ausgelöst wird.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. Beachten Sie Folgendes TestException : Wenn über Anwendungs Domänen Grenzen hinweg aufgerufen wird, wird er zweimal angezeigt: einmal für den Proxy und einmal für den Stub.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

Hinweise

Diese Klasse stellt den Ausnahmehandler für das AppDomain.FirstChanceException -Ereignis bereit, das Zugriff auf die Ausnahme hat.This class provides the exception handler for the AppDomain.FirstChanceException event with access to the exception.

Konstruktoren

FirstChanceExceptionEventArgs(Exception)

Initialisiert eine neue Instanz der FirstChanceExceptionEventArgs-Klasse mit einer angegebenen Ausnahme.Initializes a new instance of the FirstChanceExceptionEventArgs class with a specified exception.

Eigenschaften

Exception

Das verwaltete Ausnahmeobjekt, das der ausgelösten Ausnahme in verwaltetem Code entspricht.The managed exception object that corresponds to the exception thrown in managed code.

Methoden

Equals(Object)

Ermittelt, ob das angegebene Objekt und das aktuelle Objekt gleich sind.Determines whether the specified object is equal to the current object.

(Geerbt von Object)
GetHashCode()

Dient als die Standard-HashfunktionServes as the default hash function.

(Geerbt von Object)
GetType()

Ruft den Type der aktuellen Instanz ab.Gets the Type of the current instance.

(Geerbt von Object)
MemberwiseClone()

Erstellt eine flache Kopie des aktuellen Object.Creates a shallow copy of the current Object.

(Geerbt von Object)
ToString()

Gibt eine Zeichenfolge zurück, die das aktuelle Objekt darstellt.Returns a string that represents the current object.

(Geerbt von Object)

Gilt für:

Siehe auch